//---------------------------------------
// EJEMPLO4.CPP  -  StarField 3d.
// (c) 1998, S. Romero AKA NoP/Compiler,
//---------------------------------------
#include <windows.h>
#include <process.h>
#include <stdlib.h>

//--- Declaracin de funciones del programa ------------------------------
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
char OpenMusic( char * );
char PlayMusic( void );
char StopMusic( void );
char ContinueMusic( void );
char CloseMusic( void );
void InitStarField( void );
void DrawStarField( HDC );
void MoveStarField (int, int, int );
void mi_thread( void * );

#define RANDOM(min,max) ((rand()%(int)(((max)+1)-(min)))+(min))
#define MAX_STARS 2000

struct Star
{
    int x, y, z;
    int oldx, oldy;
} StarField[ MAX_STARS ]; 

//--- Declaracin de variables del programa ------------------------------
char WindowName[]  = "Ventana de Windows";
char WindowTitle[] = "Starfield 3D";
char Informacion[] = "Informacin sobre StarField 3d\n\nTecla + : Aadir estrellas\nBotones del mouse: Inc/Dec. velocidad";
int quit=0, minimised=0;
char cadena[80];
int num_stars = 200, speed = -4, xinc = 0;
DWORD start, end, frames;
MSG msg;
HDC hdc;

//=== Funcin principal WinMain() ========================================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
				    LPSTR lpCmdLine, int nCmdShow )
{
	HWND hwnd;                              // handle a la ventana ppal.
	MSG msg;                                // estructura de mensaje
	WNDCLASSEX wcx;                         // estructura de la ventana

	// Definimos la estructura de clase de ventana (campos):
	wcx.cbSize = sizeof( WNDCLASSEX );      // tamao de la estructura
	wcx.style = CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = WndProc;              // funcin de ventana (Wnd)
	wcx.cbClsExtra = 0;
	wcx.cbWndExtra = 0;                     // informaciones extra
	wcx.hInstance = hInstance;              // instancia actual
	
	// icono, cursor, fondo e icono pequeo de la clase de ventana:
	wcx.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = (HBRUSH) GetStockObject( BLACK_BRUSH );
    wcx.hIconSm = LoadIcon(NULL, IDI_WINLOGO);

	wcx.lpszMenuName = NULL;                // nombre del men
	wcx.lpszClassName = WindowName;         // nombre de la ventana

	// Registramos la clase de ventana ya preparada:
	if( !RegisterClassEx( &wcx ) )
		return( FALSE );                    // en caso de error, salir

	// Creamos la ventana con CreateWindowEx():
	hwnd = CreateWindowEx(
		WS_EX_OVERLAPPEDWINDOW,             // estilo extendido
		WindowName,                         // nombre de la ventana
		WindowTitle,                        // ttulo de la ventana
		WS_CAPTION,                         // estilo de ventana
		CW_USEDEFAULT, CW_USEDEFAULT,       // Posicin (x,y) en pantalla
		400, 300,                           // ancho y alto de la ventana
		NULL, NULL,                         // ventana padre e hija+men
		hInstance,                          // instancia actual
		NULL                                // no hay ms informacin
		                 );

	// Comprobamos la creacin de la ventana:
	if( !hwnd )
		return( FALSE );                    // en caso de error, salir	

	// Hacemos visible la ventana y la actualizamos:
	InitStarField();
	ShowWindow( hwnd, nCmdShow );
	UpdateWindow( hwnd );

	CloseMusic();
	OpenMusic("musica.mid");
	PlayMusic();
    start = GetTickCount();
    _beginthread( mi_thread, 0, NULL);

 
  // etc... 
 while (!quit)
 {
  while (PeekMessage(&msg,NULL,0,0,PM_REMOVE) )
  {
    if (msg.message == WM_QUIT) { quit=1; break; }
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  if (quit) break;


  if (minimised)
  	WaitMessage(); 
  
   else
   {
     DrawStarField(hdc=GetDC(hwnd));
	 ReleaseDC(hwnd, hdc);
   	 MoveStarField(xinc,0,speed);
   }

   // para calcular f.p.s.
   frames++;
 }

    end = GetTickCount();
    frames = (frames / ((end-start)/1000L));
	if( end != start )
      wsprintf(cadena, "Frames por segundo (sin retrazo): %d fps", frames );
    MessageBox( NULL, cadena, "StarField Info", MB_OK );

	// devolvemos el valor recibido por PostQuitMessage().
	return( msg.wParam );
}

void mi_thread( void *params )
{
  MessageBox( NULL, Informacion, "StarField Info", MB_OK | MB_ICONASTERISK);
  _endthread();
}

//=== Funcin del procedimiento de ventana WndProc() =====================
LRESULT CALLBACK WndProc( HWND hwnd, UINT message, 
						  WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
		case WM_ACTIVATEAPP:
				minimised = !wParam;
				if( minimised )
					StopMusic();
				else
					ContinueMusic();
				break;

		case WM_KEYDOWN:
				switch( wParam )
				{
					case VK_ESCAPE:
					case VK_F12:
							DestroyWindow( hwnd );
							break;
					case VK_ADD:
							if( num_stars < MAX_STARS-10 )
								num_stars+=10;
							break;
				};
				return(0);
	
		case WM_LBUTTONDOWN:
				if( speed > -6 ) speed-=1;
				break;
		case WM_RBUTTONDOWN:
				if( speed < 6 ) speed+=1;
				break;
		case WM_MBUTTONDOWN:
				speed=0; break;

		// mensaje producido al cerrar la ventana
		case WM_DESTROY:
				StopMusic();
				CloseMusic();
				PostQuitMessage(0);
				break;

		// resto de mensajes, dar una respuesta estndar.
		default:
				return( DefWindowProc( hwnd, message, wParam, lParam ) );
	}

	return(0);
}

//=== Funciones de sonido ======================================
char OpenMusic( char *filename )
{
  char buffer[256];
  wsprintf(buffer, "open %s type sequencer alias MUSIC", filename );
  return( mciSendString( buffer, 0, 0, 0 ) == 0 );
}

char PlayMusic( void )
{
  return( mciSendString("play MUSIC from 0 notify", 0, 0, 0 ) == 0 );
}

char StopMusic( void )
{
  return( mciSendString("stop MUSIC", 0, 0, 0 ) == 0 );
}

char ContinueMusic( void )
{
  // continuar desde el ltimo Stop que se hizo:
  return( mciSendString("play MUSIC notify", 0, 0, 0 ) == 0 );
}
 
char CloseMusic( void )
{
  // para permitir la reprod. de otro MIDI.
  // recomendable tambin antes de PlaySound();
  return( mciSendString("close all", 0, 0, 0 ) == 0 );
}

//=== Fin del archivo ====================================================
void InitStarField( void )
{
  for (int f=0; f<MAX_STARS; f++)
  {
     StarField[f].x = RANDOM (-400, 400);
     StarField[f].y = RANDOM (-300, 300);
     StarField[f].z = rand()%2000;
     StarField[f].oldx = -1;
     StarField[f].oldy = -1;
  }
}

void DrawStarField (HDC hdc)
{
   int sx, sy, sz;
   for (int f=0; f<num_stars; f++)
   {
	 SetPixel(hdc, StarField[f].oldx, StarField[f].oldy, RGB (0, 0, 0));
     sx = ((StarField[f].x*256)/StarField[f].z)+(400/2);
     sy = ((StarField[f].y*256)/StarField[f].z)+(300/2);
	 sz = 255-(StarField[f].z/8);
     SetPixel(hdc, sx, sy, RGB (sz, sz, sz));
     StarField[f].oldx = sx;
     StarField[f].oldy = sy;
   }
}

void MoveStarField (int xinc, int yinc, int zinc)
{
  for (int f=0; f<num_stars; f++)
  {
     StarField[f].x += xinc;
     StarField[f].y += yinc;
     StarField[f].z += zinc;

     if( StarField[f].z > 2000 )
       StarField[f].z -= 2000;
     if( StarField[f].z < 1 )
       StarField[f].z += 2000;
  }
}
