//--------------------------------------------------------------
// POLYGON.CPP  -  Trazado de polgonos de N-lados.
// (c) 24-04-1998, Santiago Romero Iglesias AKA NoP/Compiler.
// El ltimo punto ha de ser el primero de los seleccionados.
//--------------------------------------------------------------
#include <windows.h>
#include <stdlib.h>

//--- Declaracin de funciones del programa ------------------------------
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );

//--- Funciones y variables del programa ---------------------------------
int x[100], y[100];
long contador, numpoints, trazado;

//--- Declaracin de variables del programa ------------------------------
char WindowName[]  = "PolyDrawer";
char WindowTitle[] = "Dibujo de polgonos.";
char Mensaje[] = "\
Dibujo de polgonos de N lados. Mediante el ratn se seleccionan N puntos \n\
(acabando en el primero de ellos) que sern los vrtices del polgono.\n\n\
Botn izquierdo del ratn :  Seleccionar punto actual (hasta el cierre).\n\
Botn derecho del ratn   :  Borrar la lista de puntos actuales.\n\
Tecla espacio             :  Cambiar entre puntos o trazado en tiempo real.\n\
Tecla Esc  F12           :  Sale del programa.";

//=== Funcin principal WinMain() ========================================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
				    LPSTR lpCmdLine, int nCmdShow )
{
	HWND hwnd;                              // handle a la ventana ppal.
	MSG msg;                                // estructura de mensaje
	WNDCLASSEX wcx;                         // estructura de la ventana

	// Definimos la estructura de clase de ventana (campos):
	wcx.cbSize = sizeof( WNDCLASSEX );      // tamao de la estructura
	wcx.style = CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = WndProc;              // funcin de ventana (Wnd)
	wcx.cbClsExtra = wcx.cbWndExtra = 0;    // informaciones extra
	wcx.hInstance = hInstance;              // instancia actual
	
	// icono, cursor, fondo e icono pequeo de la clase de ventana:
	wcx.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );
    wcx.hIconSm = LoadIcon(NULL, IDI_WINLOGO);

	wcx.lpszMenuName = NULL;                // nombre del men
	wcx.lpszClassName = WindowName;         // nombre de la ventana

	// Registramos la clase de ventana ya preparada:
	if( !RegisterClassEx( &wcx ) )  return( FALSE );

	// Creamos la ventana con CreateWindowEx():
	hwnd = CreateWindowEx(
		WS_EX_OVERLAPPEDWINDOW, WindowName, WindowTitle,
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
		450, 350,  NULL, NULL, hInstance, NULL );

	// Comprobamos la creacin de la ventana:
	if( !hwnd )  return( FALSE );

	// Hacemos visible la ventana y la actualizamos:
	ShowWindow( hwnd, nCmdShow );
	UpdateWindow( hwnd );

	// Bucle de mensajes, enva los mensajes hacia WndProc
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );           // convertimos el mensaje
		DispatchMessage( &msg );            // devolvemos el control a w95
	}
 
	// devolvemos el valor recibido por PostQuitMessage().
	return( msg.wParam );
}

//=== Funcin del procedimiento de ventana WndProc() =====================
LRESULT CALLBACK WndProc( HWND hwnd, UINT message, 
						  WPARAM wParam, LPARAM lParam )
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rect;
	long loop;
	char cadena[20];

	switch( message )
	{
		case WM_CREATE:
				numpoints = 98;
                trazado = 1;
                contador = 0;
				break;

		case WM_KEYDOWN:
				switch( wParam )
				{
					case VK_ESCAPE:
					case VK_F12:
							DestroyWindow( hwnd );
							break;
					case VK_F1:
							MessageBox( hwnd, Mensaje,
								        WindowTitle, MB_OK | MB_ICONASTERISK );
							break;
					case VK_SPACE:
							trazado = !trazado;
							break;
				};
				return(0);
	
		// botn izquierdo: aadir puntos a los arrays hasta al lmite.
		case WM_LBUTTONDOWN:
				
				//if( contador < numpoints )
				if( contador < 98 && contador<numpoints)
				{
					x[contador]  = LOWORD(lParam);
					y[contador] = HIWORD(lParam);
					if( (x[contador] > (x[0]-5)) &&
						(x[contador] < (x[0]+5)) &&
						(y[contador] > (y[0]-5)) &&
						(y[contador] < (y[0]+5)) &&
						contador != 0 )
						{
							x[contador] = x[0];
							y[contador] = y[0];
							numpoints = contador++;
							
						}
					else
						contador++;

					GetClientRect( hwnd, &rect );
					InvalidateRect( hwnd, &rect, TRUE);
				}
				break;

		// botn derecho: borrar los nodos hasta el momento.
		case WM_RBUTTONDOWN:
				contador = 0;
				numpoints = 98;
				GetClientRect( hwnd, &rect );
				InvalidateRect( hwnd, &rect, TRUE);
				break;

        // redibujado de los puntos hasta el momento:
		case WM_PAINT:
				// coger hdc e imprimir texto de informacin:
				hdc = BeginPaint( hwnd, &ps );
				GetClientRect( hwnd, &rect );
				if( contador >= numpoints )
					wsprintf(cadena, "Vrtices: %2d.", contador-1 );
				else
					wsprintf(cadena, "Vrtices: %2d.", contador );
				TextOut(hdc, 7, rect.bottom-22, "F1 = ayuda.", 11 );
				TextOut(hdc, rect.right-108, rect.bottom-22, cadena, 13);

				// si hay al menos 1 punto, pintarlos en pantalla.
				for( loop=0; loop<contador; loop++)
					Ellipse(hdc, (int) x[loop]-2, (int) y[loop]-2,
					             (int) x[loop]+2, (int) y[loop]+2 );

				// trazar las lneas hasta el momento.
				if( (contador >= numpoints) || trazado )
				{
					MoveToEx( hdc, x[0], y[0], NULL );
					for( loop=1; loop<contador; loop++ )
						LineTo(hdc, x[loop], y[loop] );
				}

				if( contador >= (numpoints) )
				{
					TextOut(hdc, 5, 5, "Polgono finalizado.", 20 );
					// Permitir aqu otras acciones, como escalado, etc.
				}

				EndPaint( hwnd, &ps );
				break;

		// mensaje producido al cerrar la ventana
		case WM_DESTROY:
				PostQuitMessage(0);
				break;

		// resto de mensajes, dar una respuesta estndar.
		default:
				return( DefWindowProc( hwnd, message, wParam, lParam ) );
	}

	return(0);
}
